# encoding: utf-8
require "logstash/outputs/base"
require "logstash/namespace"
require 'net/http'
require 'uri'

# An example output that does nothing.
class LogStash::Outputs::Stride < LogStash::Outputs::Base
  
  config_name "stride"
  config :access_token, :validate => :string, :required => true
  config :cloud_id, :validate => :string, :required => true
  config :conversation_id, :validate => :string, :required => true
  config :message, :validate => :string, :default => "%{Message}"
  config :host, :validate => :string, :default => "%{host}"
  config :type, :validate => :string, :default => "%{type}"
  
  public
  def register
  end # def register

  public
  def receive(event)
    access_token = event.sprintf(@access_token)
    cloud_id = event.sprintf(@cloud_id)
    conversation_id = event.sprintf(@conversation_id)
    host = event.sprintf(@host)
    type = event.sprintf(@type)
    message = event.sprintf(@message)

    post_message(access_token,cloud_id,conversation_id,host,type,message)
  rescue Exception => e
    puts e.message
  end

  public
  def post_message(access_token,cloud_id,conversation_id,host,type,message)
    message = %Q|#{type} : #{message}| if type
    message = %Q|#{host} : #{message}| if host
    puts "Type : #{type}, Host : #{host}"
    uri = URI.parse("https://api.atlassian.com/site/#{cloud_id}/conversation/#{conversation_id}/message")
    request = Net::HTTP::Post.new(uri)
    request.content_type = "application/json"
    request["Authorization"] = "Bearer #{access_token}"
    request.body = '{"version":1,"type":"doc","content":[{"type":"paragraph","content":[{"type":"text","text":"'+message+'"}]}]}'

    req_options = {
      use_ssl: uri.scheme == "https",
    }

    response = Net::HTTP.start(uri.hostname, uri.port, req_options) do |http|
      http.request(request)
    end

  end
  
end # class LogStash::Outputs::Stride
